#ifndef MSP_GRAPHICS_COCOAEVENT_H_
#define MSP_GRAPHICS_COCOAEVENT_H_

#include "cocoawindow.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef enum
{
	LEFT_MOUSE_DOWN = 1,
	LEFT_MOUSE_UP = 2,
	RIGHT_MOUSE_DOWN = 3,
	RIGHT_MOUSE_UP = 4,
	MOUSE_MOVED = 5,
	KEY_DOWN = 10,
	KEY_UP = 11,
	SCROLL_WHEEL = 22,
	OTHER_MOUSE_DOWN = 25,
	OTHER_MOUSE_UP = 26,
	WINDOW_CLOSED = 1000
} CocoaEventType;

typedef struct
{
	CocoaEventType type;
	CocoaWindow *window;
} CocoaAnyEvent;

typedef struct
{
	CocoaEventType type;
	CocoaWindow *window;
	unsigned button;
	bool state;
} CocoaButtonEvent;

typedef struct
{
	CocoaEventType type;
	CocoaWindow *window;
	float x;
	float y;
} CocoaMotionEvent;

typedef struct
{
	CocoaEventType type;
	CocoaWindow *window;
	unsigned key;
	bool state;
	int character;
} CocoaKeyEvent;

typedef union
{
	CocoaEventType type;
	CocoaAnyEvent any;
	CocoaButtonEvent button;
	CocoaMotionEvent motion;
	CocoaKeyEvent key;
} CocoaEvent;

#ifdef __cplusplus
}
#endif

#endif
